/* char.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <ctype.h>
#include <unistd.h>
#include <locale.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define BUFSZ 4096

uint32_t buf[BUFSZ];
uint32_t idx[BUFSZ/8];
uint32_t bit[BUFSZ/32];

int
main( int argc, char *argv[] )
{
  int           i, f;
  uint32_t j;

  f = open( "mag.bin", O_RDONLY );
  read( f, buf, BUFSZ * sizeof( float) );
  close( f );
  f = open( "index.bin", O_RDONLY );
  read( f, idx, BUFSZ/8 * sizeof(uint32_t) );
  close( f );
  f = open( "bits.bin", O_RDONLY );
  read( f, bit, BUFSZ/32 * sizeof(uint32_t) );
  close( f );
  for( i =0; i < BUFSZ; i++ )
  {
    j = idx[i/8] >> (4 * ( i & 7 ) );
    j &= 7;
    *(uint32_t *)&buf[i] = j;
  }
  f = creat( "idx.bin", 0644 );
  write( f, buf, BUFSZ * sizeof( uint32_t ) );
  close( f );
  for( i =0; i < BUFSZ; i++ )
  {
    j = bit[i/32] >> ( i & 31 );
    j = j & 1 ? 8 : 0;
    *(uint32_t *)&buf[i] = j;
  }
  f = creat( "decode.bin", 0644 );
  write( f, buf, BUFSZ * sizeof( uint32_t ) );
  close( f );
  printf( "Done\n" );
  return 1;
}
