#ifndef configuration_h
#define configuration_h

#include "main.h"

enum config_entries
{ MAGIC_ID, 
#ifdef ENABLE_CW_DECODE
  DECODER_MODE, 
#endif // ENABLE_CW_DECODE
  SIDETONE_VOLUME, HZ_SIDETONE, WPM, WPM_FARNSWORTH,
  DAH_TO_DIT_RATIO, KEYER_MODE, PADDLE_MODE,
  SIDETONE_MODE, PTT_LEAD_TIME, PTT_TAIL_TIME,
  MEMORY_REPEAT_TIME, BEACON_MEMORY,
  CONFIG_END,
};

struct SavedOptions
{
  u16 		magic;
  u16 		id;
#ifdef ENABLE_CW_DECODE
  int           decoder_mode;
#endif // ENABLE_CW_DECODE
  int           sidetone_volume;
  int           hz_sidetone;
  int           wpm;
  int           wpm_farnsworth;
  int           dah_to_dit_ratio;
  int           keyer_mode;
  int           paddle_mode;
  int           sidetone_mode;
  int           ptt_lead_time;
  int           ptt_tail_time;
  int           memory_repeat_time;
  int           beacon_memory;
  char         *string_memory[12];
};

#define SO_SIZE ( ( sizeof( struct SavedOptions ) + 3 ) & ~3 )

enum config_mode
{ CONFIG_PARAMETER, CONFIG_VALUE };

extern struct SavedOptions Options;

#define FLASH_ERASE_TIMEOUT          ((u32)5000)      // 5s
							   
extern volatile enum config_entries current_config_entry;
extern volatile enum config_mode current_config_mode;
extern volatile int  change_val;

#define CONFIG_MAX ( sizeof( config ) / sizeof( u32 ) )

void          load_NV_Options( void );
int           save_NV_Options( void );
int           save_current_string( void );
void          Change_Options( struct SavedOptions *sv, int up_down );
void          display_parameter_value( void );
void          compute_morse_timing( void );
void          generate_sine_wave( void );

#endif
