#ifndef keyer_h
#define keyer_h

#include "cmsis_os.h"
#include "threads.h"

enum main_modes
{ M_VERSION, M_KBD_TX_RX, M_KBD_CFG, M_ENC_CFG, M_PADDLE_TX_RX, M_SAVE_OPT, M_ENTER_STRING };
enum keyer_modes
{ STRAIGHT, BUG, SINGLE_PADDLE, IAMBIC_A, IAMBIC_B, ULTIMATIC }; 
enum decoder_modes
{ DECODER_OFF, DECODER_SPLIT, DECODER_ONLY };
enum dit_dah
{ SENDING_NOTHING, SENDING_DIT, SENDING_DAH, SENDING_CW = 4, SEND_REPEAT = 8 };
enum paddle_modes
      { PADDLE_NORMAL, PADDLE_REVERSE };
enum paddle_states
     { PAD_LR, PAD_L, PAD_R, PAD_NONE };
enum sidetone_modes
{ SIDETONE_OFF, SIDETONE_ON, SIDETONE_PADDLE_ONLY };

#define PARAMETER_TIMEOUT ( 400 * 4 ) 
#define SAVEOPT_TIMEOUT ( 400 * 3 ) 
#define SAMPLING_RATE 16000
#define SAMPLE_BUF_LEN 64
#define OUTPUT_RATE 16000
#define DECAY_STEPS 12
#define MIN_SINE_SAMPLES 8
#define MAX_SINE_SAMPLES 40
#define MIN_VOLUME_DB 15
#define MAX_VOLUME_DB 60
#define CW_BUF_LEN 64
#define MAX_STRING_SIZE CW_BUF_LEN
#define MAX_CW_EVENTS 256
#define DECODER_BUF_LEN 4096
#define DELTAS_BUF_LEN 256
#define CHAR_BUF_LEN (DELTAS_BUF_LEN/5)

#endif                          // keyer_h
