/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  */
/* USER CODE END Header */

// Define to prevent recursive inclusion -------------------------------------
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

// Includes ------------------------------------------------------------------
#include "stm32f4xx_hal.h"

// Private includes ----------------------------------------------------------
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

// Exported types ------------------------------------------------------------
/* USER CODE BEGIN ET */
typedef __IO uint64_t  vu64;
typedef __IO uint32_t  vu32;
typedef __IO uint16_t  vu16;
typedef __IO uint8_t  vu8;
typedef uint64_t u64;
typedef uint32_t u32;
typedef uint16_t u16;
typedef uint8_t u8;
typedef int 	bool;
/* USER CODE END ET */

// Exported constants --------------------------------------------------------
/* USER CODE BEGIN EC */
extern volatile enum device_modes mode;
/* USER CODE END EC */

// Exported macro ------------------------------------------------------------
/* USER CODE BEGIN EM */

/* USER CODE END EM */

// Exported functions prototypes ---------------------------------------------
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

// Private defines -----------------------------------------------------------
#define Tx_PTT_Pin GPIO_PIN_13
#define Tx_PTT_GPIO_Port GPIOC
#define ENC_Sw_Pin GPIO_PIN_0
#define ENC_Sw_GPIO_Port GPIOA
#define Enc_A_Pin GPIO_PIN_1
#define Enc_A_GPIO_Port GPIOA
#define Enc_B_Pin GPIO_PIN_2
#define Enc_B_GPIO_Port GPIOA
#define Spare_Pin GPIO_PIN_3
#define Spare_GPIO_Port GPIOA
#define PAD_L_Pin GPIO_PIN_0
#define PAD_L_GPIO_Port GPIOB
#define PAD_R_Pin GPIO_PIN_1
#define PAD_R_GPIO_Port GPIOB
#define Tx_CW_Pin GPIO_PIN_2
#define Tx_CW_GPIO_Port GPIOB
#define LCD_RS_Pin GPIO_PIN_10
#define LCD_RS_GPIO_Port GPIOB
#define Sw_Right_Pin GPIO_PIN_14
#define Sw_Right_GPIO_Port GPIOB
#define Sw_Left_Pin GPIO_PIN_8
#define Sw_Left_GPIO_Port GPIOA
#define Tx_Pin GPIO_PIN_9
#define Tx_GPIO_Port GPIOA
#define Rx_Pin GPIO_PIN_10
#define Rx_GPIO_Port GPIOA
#define LCD_E_Pin GPIO_PIN_4
#define LCD_E_GPIO_Port GPIOB
#define LCD_D4_Pin GPIO_PIN_6
#define LCD_D4_GPIO_Port GPIOB
#define LCD_D5_Pin GPIO_PIN_7
#define LCD_D5_GPIO_Port GPIOB
#define LCD_D6_Pin GPIO_PIN_8
#define LCD_D6_GPIO_Port GPIOB
#define LCD_D7_Pin GPIO_PIN_9
#define LCD_D7_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */

#define enableInterrupts()   __set_PRIMASK(0);
#define disableInterrupts()  __set_PRIMASK(1);
#define pinSet(Port,Pin)     Port->BSRR = (Pin)
#define pinReset(Port,Pin)   Port->BSRR = (u32)(Pin) << 16U
#define pinToggle(Port,Pin)  Port->ODR ^= (Pin)
#define pinRead(Port,Pin)    !!(Port->IDR & (Pin))

#define false 0
#define true  1

extern u8 __IVT_segment_start__;
extern u8 __IVT_segment_end__;
extern u8 __IVT_segment_size__;
extern u8 __STRINGS_segment_start__;
extern u8 __STRINGS_segment_end__;
extern u8 __STRINGS_segment_size__;
extern u8 __OPTIONS_segment_start__;
extern u8 __OPTIONS_segment_end__;
extern u8 __OPTIONS_segment_size__;

// comment out the line bellow if you don't want the CW decoder
#define ENABLE_CW_DECODE

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
